package uk.ac.gla.photofight;

import uk.ac.gla.photofight.fight.SelectFightersActivity;
import uk.ac.gla.photofight.personalize.PersonalizeActivity;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;
import android.widget.Toast;

public class MainMenuActivity extends Activity implements OnClickListener {
	
	TextView fightButton;
	TextView personalizeButton;
	TextView helpButton;
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		fightButton = (TextView) findViewById(R.id.main_menu_fight_button);
		fightButton.setOnClickListener(this);

		personalizeButton = (TextView) findViewById(R.id.personalize_button);
		personalizeButton.setOnClickListener(this);

		helpButton = (TextView) findViewById(R.id.help_button);
		helpButton.setOnClickListener(this);

		Typeface tf = Typeface.createFromAsset(this.getAssets(), "hot-mustard-btn.ttf");
		fightButton.setTypeface(tf);
		personalizeButton.setTypeface(tf);
		helpButton.setTypeface(tf);
	}
	
	public void onResume () {
		super.onResume();
		if (Storage.getFighterNames(MainMenuActivity.this).size() == 0)
			fightButton.setEnabled(false);
		else
			fightButton.setEnabled(true);
	}

	@Override
	public void onClick(View v) {
		if (!Storage.isSdPresent()) {
			Toast.makeText(MainMenuActivity.this,
					"You should first mount an SD card",
					Toast.LENGTH_SHORT).show();
			return;
		}
		if (v == fightButton) 
			startActivity(new Intent(MainMenuActivity.this, SelectFightersActivity.class));
		else if (v == personalizeButton)
			startActivity(new Intent(MainMenuActivity.this, PersonalizeActivity.class));
		else if (v == helpButton)
			// TODO
			return;
	}

	
}