package uk.ac.gla.photofight;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.MotionEvent;

public class SplashScreenActivity extends Activity {
	
	private final int SPLASH_TIME = 5000;
	
	private Thread splashThread;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.splash);
		
		splashThread = new Thread () {
			@Override
			public void run() {
				try {
					synchronized(this) {
						wait(SPLASH_TIME);
					}
				} catch (InterruptedException e) {
				} finally {
					finish();
					Intent i = new Intent(SplashScreenActivity.this, MainMenuActivity.class);
					startActivity(i);
					
//					stop();
				}
				
			}
		};
		
		splashThread.start();
	}
	
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		if (event.getAction() == MotionEvent.ACTION_DOWN) {
			synchronized(splashThread) {
				splashThread.notifyAll();
			}
		}
		return true;
	}

}
