package uk.ac.gla.photofight.fight;

import uk.ac.gla.photofight.R;
import uk.ac.gla.photofight.fight.FightView.FightThread;
import android.app.Activity;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.widget.FrameLayout;
import android.widget.ImageButton;

public class FightActivity extends Activity implements OnTouchListener,
		OnClickListener {

	private FightView fightView;
	

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.fight);

		fightView = (FightView) findViewById(R.id.fight_view);

		FrameLayout fightFrame = (FrameLayout) findViewById(R.id.fight_frame);

		View buttonsView = getLayoutInflater().inflate(R.layout.fight_buttons,
				null);

		ImageButton rightButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_right_imageButton);
		rightButton.setOnTouchListener(this);

		ImageButton leftButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_left_imageButton);
		leftButton.setOnTouchListener(this);

		ImageButton downButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_down_imageButton);
		downButton.setOnTouchListener(this);

		ImageButton upButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_up_imageButton);
		upButton.setOnClickListener(this);

		ImageButton kickButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_kick_imageButton);
		kickButton.setOnClickListener(this);

		ImageButton punchButton = (ImageButton) buttonsView
				.findViewById(R.id.fight_buttons_punch_imageButton);
		punchButton.setOnClickListener(this);

		fightFrame.addView(buttonsView);
	}

	@Override
	public boolean onTouch(View v, MotionEvent event) {
		switch (v.getId()) {
		case R.id.fight_buttons_right_imageButton:
			if (event.getAction() == MotionEvent.ACTION_DOWN)
				fightView.rightCursorDown();
			else if (event.getAction() == MotionEvent.ACTION_UP)
				fightView.rightCursorUp();
			break;
		case R.id.fight_buttons_left_imageButton:
			if (event.getAction() == MotionEvent.ACTION_DOWN)
				fightView.leftCursorDown();
			else if (event.getAction() == MotionEvent.ACTION_UP)
				fightView.leftCursorUp();
			break;
		case R.id.fight_buttons_down_imageButton:
			if (event.getAction() == MotionEvent.ACTION_DOWN)
				fightView.downCursorDown();
			else if (event.getAction() == MotionEvent.ACTION_UP)
				fightView.downCursorUp();
			break;
		}
		return false;
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.fight_buttons_up_imageButton:
			fightView.upClicked();
			break;
		case R.id.fight_buttons_kick_imageButton:
			fightView.kickClicked();
			break;
		case R.id.fight_buttons_punch_imageButton:
			fightView.punchClicked();
			break;
		}
	}

	@Override
	public void onDestroy() {
//		FightThread fightThread = fightView.getFightThread();
//		
//		ControlFighterThread aiThread = fightThread.getAIThread();
//		aiThread.interrupt();
//		fightThread.interrupt();
		
		fightView.fightFinished();
		
		super.onDestroy();
	}

}
