package uk.ac.gla.photofight.personalize;

import uk.ac.gla.photofight.R;
import uk.ac.gla.photofight.Storage;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class CreateFighterActivity extends Activity {

	EditText nameEditText;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.create_fighter);

		nameEditText = (EditText) findViewById(R.id.create_fighter_name_editText);

		TextView continueButton = (TextView) findViewById(R.id.create_fighter_continue_button);
		continueButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				String name = nameEditText.getEditableText().toString();
				if (name.equals("")) {
					Toast.makeText(CreateFighterActivity.this,
							"Enter a name before continuing",
							Toast.LENGTH_SHORT).show();
					return;
				}
				if (Storage.getFighterNames(CreateFighterActivity.this).contains(name)) {
					Toast.makeText(CreateFighterActivity.this,
							"Name already exists",
							Toast.LENGTH_SHORT).show();
					return;
				}

				SharedPreferences settings = getSharedPreferences("photoFight",
						0);
				SharedPreferences.Editor editor = settings.edit();
				editor.putString("fighterName", name);
				editor.commit();
				
				startActivity(new Intent(CreateFighterActivity.this, InsertMediaToCharacterActivity.class));
				finish();
			}
		});

		TextView backButton = (TextView) findViewById(R.id.create_fighter_back_button);
		backButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});
		
		TextView addInfoTextView = (TextView) findViewById(R.id.create_fighter_add_info_textView);

        Typeface tf = Typeface.createFromAsset(this.getAssets(), "hot-mustard-btn.ttf");
        continueButton.setTypeface(tf);
        backButton.setTypeface(tf);
        addInfoTextView.setTypeface(tf);
		

	}

}
