package uk.ac.gla.photofight.personalize;

import java.util.ArrayList;
import java.util.List;

import uk.ac.gla.photofight.Fighter;
import uk.ac.gla.photofight.FighterArrayAdapter;
import uk.ac.gla.photofight.R;
import uk.ac.gla.photofight.Storage;
import uk.ac.gla.photofight.fight.FightActivity;
import uk.ac.gla.photofight.fight.SelectFightersActivity;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

public class EditFighterActivity extends Activity implements OnItemClickListener, OnClickListener {
	
	private ListView fightersListView;
	private List<Fighter> fighterList;
	private FighterArrayAdapter fighterArrayAdapter;
	private TextView selectedFighterNameTextView;
	private ImageView selectedFighterImageView;
	private String selectedFighterName;
	private TextView editButton;
	private TextView backButton;


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.edit_fighter);

		fightersListView = (ListView) findViewById(R.id.edit_fighter_listView);
		
		fighterList = new ArrayList<Fighter>();
		for (String fighterName : Storage
				.getFighterNames(EditFighterActivity.this)) {
			Fighter fighter = new Fighter(EditFighterActivity.this,
					fighterName);
			fighterList.add(fighter);
		}

		fighterArrayAdapter = new FighterArrayAdapter(
				EditFighterActivity.this, R.layout.fighter_row, fighterList);

		fightersListView.setAdapter(fighterArrayAdapter);
		fightersListView.setOnItemClickListener(this);

		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inSampleSize = 4;
		Bitmap defaultBitmap = BitmapFactory.decodeResource(getResources(),
				R.drawable.bgvictory_defeat, options);

		selectedFighterNameTextView = (TextView) findViewById(R.id.edit_fighter_selected_fighter_name);
		selectedFighterImageView = (ImageView) findViewById(R.id.edit_fighter_selected_fighter_imageView);
		selectedFighterImageView.setImageBitmap(defaultBitmap);

		editButton = (TextView) findViewById(R.id.edit_fighter_edit_button);
		editButton.setOnClickListener(this);
		backButton = (TextView) findViewById(R.id.edit_fighter_back_button);
		backButton.setOnClickListener(this);

		TextView infoTextView = (TextView) findViewById(R.id.edit_fighter_info);

        Typeface tf = Typeface.createFromAsset(this.getAssets(), "hot-mustard-btn.ttf");
        editButton.setTypeface(tf);
        backButton.setTypeface(tf);
        selectedFighterNameTextView.setTypeface(tf);
        infoTextView.setTypeface(tf);
	}


	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {
		selectedFighterName = fighterList.get(position).name;
		selectedFighterNameTextView.setText(fighterList.get(position).name);
		selectedFighterImageView
				.setImageBitmap(fighterList.get(position).victoryBitmap);
	}


	@Override
	public void onClick(View v) {
		if (v == editButton) {
			SharedPreferences settings = getSharedPreferences("photoFight", 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putString("fighterName", selectedFighterName);
			editor.commit();
			
//			Intent i = new Intent(new Intent(EditFighterActivity.this,
//					FightActivity.class));
//			i.putExtra("selectedFighterName", selectedFighterName);
			
			startActivity(new Intent(EditFighterActivity.this,
					InsertMediaToCharacterActivity.class));
			finish();
		} else if (v == backButton)
			finish();
	}

	private void checkFightButton() {
		if (selectedFighterName != null)
			editButton.setEnabled(true);
		else
			editButton.setEnabled(false);
	}
	

}
