package uk.ac.gla.photofight.personalize;

import java.io.File;
import java.io.IOException;

import uk.ac.gla.photofight.R;
import uk.ac.gla.photofight.Storage;
import android.app.Activity;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaRecorder;
import android.media.MediaRecorder.OnInfoListener;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

public class RecordVoiceActivity extends Activity {
	
	private MediaRecorder recorder;
//	private Handler mHandler;
	private File recordingFile;
//	private ProgressBar amplitudeBar;
//	private Runnable updateAmplitudeBarRunnable;
	
	private String fighterName;
	private String type;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.voice_record);
		
		SharedPreferences settings = getSharedPreferences("photoFight", 0);
		fighterName = settings.getString("fighterName", null);
		
		type = getIntent().getExtras().getString("type");
		
		TextView titleTextView = (TextView) findViewById(R.id.voice_record_title_textView);
		titleTextView.setText("Record \"" + type + "\" voice (" + (recordingLength() / 1000) + " seconds)\n" + 
								"Please speak loud and clear next to the microphone");

		recordingFile = Storage.getOutputMediaFile(RecordVoiceActivity.this, fighterName, type + ".3gpp");
		
//        amplitudeBar = (ProgressBar) findViewById(R.id.voice_amplitude_progressBar);
//        
//        mHandler = new Handler();
//        updateAmplitudeBarRunnable = new Runnable() {
//			
//			@Override
//			public void run() {
//				Log.i("maxAmplitude", "" + recorder.getMaxAmplitude());
//				amplitudeBar.setProgress(recorder.getMaxAmplitude());
//				mHandler.postDelayed(updateAmplitudeBarRunnable, 100);					
//			}
//        };
        
        TextView backButton = (TextView) findViewById(R.id.voice_record_back_button);
        backButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				finish();
			}
		});
        
        TextView voiceRecordButton = (TextView) findViewById(R.id.voice_record_button);
        voiceRecordButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				// Set up the amplitude bar
//				recordingFinished = false;
//		        new Thread(new Runnable() {
//					
//					@Override
//					public void run() {
//						Log.i("Amplitude outer thread", "started");
//						while (!recordingFinished) {
//							mHandler.post(new Runnable() {
//								@Override
//								public void run() {
//									Log.i("maxAmplitude", "" + recorder.getMaxAmplitude());
//									amplitudeBar.setProgress(recorder.getMaxAmplitude());
//								}
//							});
//						}
//					}
//				}).run();
		        
		        recorder = new MediaRecorder();
		        recorder.setAudioSource(MediaRecorder.AudioSource.MIC);
		        recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);
		        recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC);
		        recorder.setAudioEncodingBitRate(16);
		        recorder.setAudioSamplingRate(44100);
		        recorder.setOutputFile(recordingFile.getAbsolutePath());
		        recorder.setMaxDuration(recordingLength());
		        recorder.setOnInfoListener(new OnInfoListener() {

					@Override
					public void onInfo(MediaRecorder mr, int what, int extra) {
						if (what == MediaRecorder.MEDIA_RECORDER_INFO_MAX_DURATION_REACHED) {
							Log.i("MediaRecorder", "Max duration reached");
					        recorder.stop();
					        recorder.reset();   // You can reuse the object by going back to setAudioSource() step
					        recorder.release(); // Now the object cannot be reused
//					        mHandler.removeCallbacks(updateAmplitudeBarRunnable);
						}
					}
		        	
		        });
		        try {
					recorder.prepare();
				} catch (IllegalStateException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
//				mHandler.post(updateAmplitudeBarRunnable);
				recorder.start();   // Recording is now started
			}
		});
        
        TextView playRecordingButton = (TextView) findViewById(R.id.play_recording_button);
        playRecordingButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Uri myUri = Uri.fromFile(recordingFile); // initialize Uri here
				MediaPlayer mediaPlayer = new MediaPlayer();
				mediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
				try {
					mediaPlayer.setDataSource(getApplicationContext(), myUri);
					mediaPlayer.prepare();
					mediaPlayer.setVolume(1.0f, 1.0f);
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (SecurityException e) {
					e.printStackTrace();
				} catch (IllegalStateException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
				mediaPlayer.start();
			}
		});
        
        TextView infoTextView = (TextView) findViewById(R.id.voice_record_info_textView);

        Typeface tf = Typeface.createFromAsset(this.getAssets(), "hot-mustard-btn.ttf");
        infoTextView.setTypeface(tf);
        titleTextView.setTypeface(tf);
        backButton.setTypeface(tf);
        voiceRecordButton.setTypeface(tf);
        playRecordingButton.setTypeface(tf);

        
    }
    
    private int recordingLength() {
    	if (type.equals("hit") || type.equals("take_hit"))
    		return 3000;
    	else if (type.equals("winning") || type.equals("defeat"))
    		return 4000;
    	else if (type.equals("victory"))
    		return 6000;
    	else
    		return 0;
    }


}
